;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (Linux)
;--------------------------------------------------------
; PIC port for the 14-bit core
;--------------------------------------------------------
;	.file	"blink_led_16f688.c"
	list	p=16f688
	radix dec
	include "p16f688.inc"
;--------------------------------------------------------
; config word(s)
;--------------------------------------------------------
	__config 0x33d4
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	__waitS
	extern	__waitM
	extern	__waitL
	extern	_forCalibOsc
	extern	_initUsart
	extern	_receiveUsart
	extern	_transmitUsart
	extern	_transmitUsartNb
	extern	_clearIrSig
	extern	_receiveIrSig
	extern	_transmitIrSig
	extern	_STATUSbits
	extern	_PORTAbits
	extern	_PORTCbits
	extern	_INTCONbits
	extern	_PIR1bits
	extern	_T1CONbits
	extern	_BAUDCTLbits
	extern	_TXSTAbits
	extern	_RCSTAbits
	extern	_WDTCONbits
	extern	_CMCON0bits
	extern	_CMCON1bits
	extern	_ADCON0bits
	extern	_OPTION_REGbits
	extern	_TRISAbits
	extern	_TRISCbits
	extern	_PIE1bits
	extern	_PCONbits
	extern	_OSCCONbits
	extern	_OSCTUNEbits
	extern	_ANSELbits
	extern	_WPUbits
	extern	_WPUAbits
	extern	_IOCbits
	extern	_IOCAbits
	extern	_VRCONbits
	extern	_EECON1bits
	extern	_ADCON1bits
	extern	_waitCntS
	extern	_waitCntM
	extern	_waitCntL
	extern	_irsig
	extern	_INDF
	extern	_TMR0
	extern	_PCL
	extern	_STATUS
	extern	_FSR
	extern	_PORTA
	extern	_PORTC
	extern	_PCLATH
	extern	_INTCON
	extern	_PIR1
	extern	_TMR1
	extern	_TMR1L
	extern	_TMR1H
	extern	_T1CON
	extern	_BAUDCTL
	extern	_SPBRGH
	extern	_SPBRG
	extern	_RCREG
	extern	_TXREG
	extern	_TXSTA
	extern	_RCSTA
	extern	_WDTCON
	extern	_CMCON0
	extern	_CMCON1
	extern	_ADRESH
	extern	_ADCON0
	extern	_OPTION_REG
	extern	_TRISA
	extern	_TRISC
	extern	_PIE1
	extern	_PCON
	extern	_OSCCON
	extern	_OSCTUNE
	extern	_ANSEL
	extern	_WPU
	extern	_WPUA
	extern	_IOC
	extern	_IOCA
	extern	_EEDATH
	extern	_EEADRH
	extern	_VRCON
	extern	_EEDAT
	extern	_EEDATA
	extern	_EEADR
	extern	_EECON1
	extern	_EECON2
	extern	_ADRESL
	extern	_ADCON1
	extern	___sdcc_saved_fsr
	extern	__sdcc_gsinit_startup
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_Intr
	global	_main
	global	_id_location
	global	_eedata

	global PSAVE
	global SSAVE
	global WSAVE
	global STK12
	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0070
PSAVE	res 1
SSAVE	res 1
WSAVE	res 1
STK12	res 1
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

ID_blink_led_16f688_0	code	0x2000
_id_location
	retlw 0x41
	retlw 0x42
	retlw 0x43
	retlw 0x44


ID_blink_led_16f688_1	code	0x2100
_eedata
	retlw 0x64
	retlw 0x75
	retlw 0x6d
	retlw 0x6d
	retlw 0x79
	retlw 0x00

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	nop
	pagesel __sdcc_gsinit_startup
	goto	__sdcc_gsinit_startup
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0004
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;; Starting pCode block
_Intr:
; 0 exit points
;	.line	30; "blink_led_16f688.c"	void Intr(void) __interrupt 0 {
	MOVWF	WSAVE
	SWAPF	STATUS,W
	CLRF	STATUS
	MOVWF	SSAVE
	MOVF	PCLATH,W
	CLRF	PCLATH
	MOVWF	PSAVE
	MOVF	FSR,W
	BANKSEL	___sdcc_saved_fsr
	MOVWF	___sdcc_saved_fsr
;	.line	31; "blink_led_16f688.c"	T0IF = 0;						// Clear timer interrupt
	BANKSEL	_INTCONbits
	BCF	_INTCONbits,2
	BANKSEL	___sdcc_saved_fsr
	MOVF	___sdcc_saved_fsr,W
	BANKSEL	FSR
	MOVWF	FSR
	MOVF	PSAVE,W
	MOVWF	PCLATH
	CLRF	STATUS
	SWAPF	SSAVE,W
	MOVWF	STATUS
	SWAPF	WSAVE,F
	SWAPF	WSAVE,W
END_OF_INTERRUPT:
	RETFIE	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_blink_led_16f688	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _initUsart
;   _transmitUsart
;   __waitL
;   _transmitIrSig
;   _transmitUsart
;   __waitL
;   _initUsart
;   _transmitUsart
;   __waitL
;   _transmitIrSig
;   _transmitUsart
;   __waitL
;; Starting pCode block
S_blink_led_16f688__main	code
_main:
; 2 exit points
;	.line	48; "blink_led_16f688.c"	PORTA		= 0b00000000;		// RA3: input only
	BANKSEL	_PORTA
	CLRF	_PORTA
;	.line	49; "blink_led_16f688.c"	CMCON0		= 0b00000111;
	MOVLW	0x07
	MOVWF	_CMCON0
;	.line	50; "blink_led_16f688.c"	ANSEL		= 0b00000000;
	BANKSEL	_ANSEL
	CLRF	_ANSEL
;	.line	51; "blink_led_16f688.c"	TRISA		= 0b00001000;		// 1: 入力, 0: 出力
	MOVLW	0x08
	MOVWF	_TRISA
;	.line	53; "blink_led_16f688.c"	PORTC		= 0b00000000;
	BANKSEL	_PORTC
	CLRF	_PORTC
;	.line	54; "blink_led_16f688.c"	TRISC		= 0b00110001;		// 1: 入力, 0: 出力
	MOVLW	0x31
	BANKSEL	_TRISC
	MOVWF	_TRISC
;	.line	56; "blink_led_16f688.c"	OPTION_REG	= 0b11111111;		// 初期値:0b11111111
	MOVLW	0xff
	MOVWF	_OPTION_REG
;	.line	65; "blink_led_16f688.c"	INTCON		= 0b00000000;		// 初期値:0b0000000x
	BANKSEL	_INTCON
	CLRF	_INTCON
;	.line	75; "blink_led_16f688.c"	PIR1		= 0b00000000;		// 初期値:0b00000000(フラグ)
	CLRF	_PIR1
;	.line	76; "blink_led_16f688.c"	PIE1		= 0b00000000;		// 初期値:0b00000000(イネーブル)
	BANKSEL	_PIE1
	CLRF	_PIE1
;	.line	86; "blink_led_16f688.c"	T1CON		= 0b00000000;		// 初期値:0b00000000
	BANKSEL	_T1CON
	CLRF	_T1CON
;	.line	96; "blink_led_16f688.c"	initUsart();
	PAGESEL	_initUsart
	CALL	_initUsart
	PAGESEL	$
_00110_DS_:
;	.line	103; "blink_led_16f688.c"	LED1 = 1;
	BANKSEL	_PORTAbits
	BSF	_PORTAbits,0
;	.line	104; "blink_led_16f688.c"	transmitUsart(0x55);
	MOVLW	0x55
	PAGESEL	_transmitUsart
	CALL	_transmitUsart
	PAGESEL	$
	
	movlw 5 ; LD A, 5; 
	
	PAGESEL	__waitL
	CALL	__waitL
	PAGESEL	$
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	114; "blink_led_16f688.c"	irsig[0] = 0x2A;			// DENON CEOL RCD-N9 VOLUME DOWN
	MOVLW	0x2a
	BANKSEL	_irsig
	MOVWF	(_irsig + 0)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	115; "blink_led_16f688.c"	irsig[1] = 0x4C;
	MOVLW	0x4c
	MOVWF	(_irsig + 1)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	116; "blink_led_16f688.c"	irsig[2] = 0x0A;
	MOVLW	0x0a
	MOVWF	(_irsig + 2)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	117; "blink_led_16f688.c"	irsig[3] = 0x8A;
	MOVLW	0x8a
	MOVWF	(_irsig + 3)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	118; "blink_led_16f688.c"	irsig[4] = 0x02;
	MOVLW	0x02
	MOVWF	(_irsig + 4)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	119; "blink_led_16f688.c"	irsig[5] = 0x82;
	MOVLW	0x82
	MOVWF	(_irsig + 5)
;;gen.c:6559: size=0, offset=0, AOP_TYPE(res)=8
;	.line	120; "blink_led_16f688.c"	irsig[6] = 0xFF;
	MOVLW	0xff
	MOVWF	(_irsig + 6)
;	.line	121; "blink_led_16f688.c"	transmitIrSig();
	PAGESEL	_transmitIrSig
	CALL	_transmitIrSig
	PAGESEL	$
;	.line	123; "blink_led_16f688.c"	LED1 = 0;
	BANKSEL	_PORTAbits
	BCF	_PORTAbits,0
;	.line	124; "blink_led_16f688.c"	transmitUsart(0xAA);
	MOVLW	0xaa
	PAGESEL	_transmitUsart
	CALL	_transmitUsart
	PAGESEL	$
	
	movlw 10 ; LD A, 10; 
	
	PAGESEL	__waitL
	CALL	__waitL
	PAGESEL	$
	GOTO	_00110_DS_
	RETURN	
; exit point of _main


;	code size estimation:
;	   61+   26 =    87 instructions (  226 byte)

	end
