;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (Linux)
;--------------------------------------------------------
; PIC port for the 14-bit core
;--------------------------------------------------------
;	.file	"libirsig.c"
	list	p=16f688
	radix dec
	include "p16f688.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	__waitS
	extern	__waitM
	extern	__waitL
	extern	_forCalibOsc
	extern	_STATUSbits
	extern	_PORTAbits
	extern	_PORTCbits
	extern	_INTCONbits
	extern	_PIR1bits
	extern	_T1CONbits
	extern	_BAUDCTLbits
	extern	_TXSTAbits
	extern	_RCSTAbits
	extern	_WDTCONbits
	extern	_CMCON0bits
	extern	_CMCON1bits
	extern	_ADCON0bits
	extern	_OPTION_REGbits
	extern	_TRISAbits
	extern	_TRISCbits
	extern	_PIE1bits
	extern	_PCONbits
	extern	_OSCCONbits
	extern	_OSCTUNEbits
	extern	_ANSELbits
	extern	_WPUbits
	extern	_WPUAbits
	extern	_IOCbits
	extern	_IOCAbits
	extern	_VRCONbits
	extern	_EECON1bits
	extern	_ADCON1bits
	extern	_waitCntS
	extern	_waitCntM
	extern	_waitCntL
	extern	_INDF
	extern	_TMR0
	extern	_PCL
	extern	_STATUS
	extern	_FSR
	extern	_PORTA
	extern	_PORTC
	extern	_PCLATH
	extern	_INTCON
	extern	_PIR1
	extern	_TMR1
	extern	_TMR1L
	extern	_TMR1H
	extern	_T1CON
	extern	_BAUDCTL
	extern	_SPBRGH
	extern	_SPBRG
	extern	_RCREG
	extern	_TXREG
	extern	_TXSTA
	extern	_RCSTA
	extern	_WDTCON
	extern	_CMCON0
	extern	_CMCON1
	extern	_ADRESH
	extern	_ADCON0
	extern	_OPTION_REG
	extern	_TRISA
	extern	_TRISC
	extern	_PIE1
	extern	_PCON
	extern	_OSCCON
	extern	_OSCTUNE
	extern	_ANSEL
	extern	_WPU
	extern	_WPUA
	extern	_IOC
	extern	_IOCA
	extern	_EEDATH
	extern	_EEADRH
	extern	_VRCON
	extern	_EEDAT
	extern	_EEDATA
	extern	_EEADR
	extern	_EECON1
	extern	_EECON2
	extern	_ADRESL
	extern	_ADCON1

	extern PSAVE
	extern SSAVE
	extern WSAVE
	extern STK12
	extern STK11
	extern STK10
	extern STK09
	extern STK08
	extern STK07
	extern STK06
	extern STK05
	extern STK04
	extern STK03
	extern STK02
	extern STK01
	extern STK00
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_transmitIrSig
	global	_receiveIrSig
	global	_clearIrSig
	global	_irsig

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_libirsig_0	udata
_irsig	res	30

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_libirsig_0	udata
r0x1026	res	1
r0x1027	res	1
r0x1020	res	1
r0x1021	res	1
r0x1022	res	1
r0x1023	res	1
r0x1024	res	1
r0x1025	res	1
_sig_p	res	1
_sig_b	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; code
;--------------------------------------------------------
code_libirsig	code
;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_libirsig__transmitIrSig	code
_transmitIrSig:
; 2 exit points
	movlw	_irsig ; LD A, _irsig
	movwf	FSR ; LD IX, A
IrSig:
	; IrSig: ; leader
	movlw	133 ; LD A, 133 ; 3500us / 26.3us = 133
	movwf	_sig_p ; LD (_sig_p), A
	call	IrActive ; CALL IrActive
	movlw	65 ; LD A, 65 ; 1700us / 26.3us = 65
	movwf	_sig_p ; LD (_sig_p), A
	call	IrInactive ; CALL IrInactive
IrSig1:
	; IrSig1:
	movlw	0xFF ; LD A, 0xFF
	subwf	INDF, W ; SUB (IX), A>A
	btfsc	STATUS, 2
	goto	IrSig9 ; JP STATUSbits.Z, IrSig9 ; STATUSbits.Z: bit 2
	;
	movlw	8 ; LD A, 8
	movwf	_sig_b ; LD (_sig_b), A
IrSig2:
	; IrSig2:
	rlf	INDF, F ; RL (IX)
	btfsc	STATUS, 0
	goto	IrSig3 ; JP STATUSbits.C, IrSig3 ; STATUSbits.C: bit 0
	;	; ---- '0' signal ----
	;	; LD A, 18 ; 480us / 26.3us = 18
	movlw	15 ; LD A, 15 ; 400us / 26.3us = 15
	movwf	_sig_p ; LD (_sig_p), A
	call	IrActive ; CALL IrActive
	;	; LD A, 14 ; 380us / 26.3us = 14
	movlw	21 ; LD A, 21 ; 550us / 26.3us = 21
	movwf	_sig_p ; LD (_sig_p), A
	call	IrInactive ; CALL IrInactive
	goto	IrSig4 ; JP IrSig4
IrSig3:
	; IrSig3: ; ---- '1' signal ----
	;	; LD A, 18 ; 480us / 26.3us = 18
	movlw	15 ; LD A, 15 ; 400us / 26.3us = 15
	movwf	_sig_p ; LD (_sig_p), A
	call	IrActive ; CALL IrActive
	;	; LD A, 47 ; 1230us / 26.3us = 47
	movlw	55 ; LD A, 55 ; 1450us / 26.3us = 55
	movwf	_sig_p ; LD (_sig_p), A
	call	IrInactive ; CALL IrInactive
IrSig4:
	; IrSig4:
	decfsz	_sig_b, F
	goto	IrSig2 ; DJNZ (_sig_b), IrSig2
	incf	FSR, F ; INC IX
	goto	IrSig1 ; JP IrSig1
IrSig9:
	; IrSig9: ; trailer
	;	; LD A, 18 ; 480us / 26.3us = 18
	movlw	15 ; LD A, 15 ; 400us / 26.3us = 15
	movwf	_sig_p ; LD (_sig_p), A
	call	IrActive ; CALL IrActive
	return	; RET
	;
IrActive:
	; IrActive: ; 38kHz = 26.32us
	bsf	_PORTC, 1 ; SET 1, (_PORTC) ; 0
	nop	; NOP ; 1
	nop	; NOP ; 2
	nop	; NOP ; 3
	nop	; NOP ; 4
	nop	; NOP ; 5
	nop	; NOP ; 6
	nop	; NOP ; 7
	bcf	_PORTC, 1 ; RES 1, (_PORTC) ; 8
	nop	; NOP ; 9
	nop	; NOP ; 10
	nop	; NOP ; 11
	nop	; NOP ; 12
	nop	; NOP ; 13
	nop	; NOP ; 14
	nop	; NOP ; 15
	nop	; NOP ; 16
	nop	; NOP ; 17
	nop	; NOP ; 18
	nop	; NOP ; 19
	nop	; NOP ; 20
	nop	; NOP ; 21
	nop	; NOP ; 22
	decfsz	_sig_p, F
	goto	IrActive ; DJNZ (_sig_p), IrActive ; 23, 24, 25
	return	; RET
	;
IrInactive:
	; IrInactive: ; 38kHz = 26.32us
	nop	; NOP ; 0
	nop	; NOP ; 1
	nop	; NOP ; 2
	nop	; NOP ; 3
	nop	; NOP ; 4
	nop	; NOP ; 5
	nop	; NOP ; 6
	nop	; NOP ; 7
	nop	; NOP ; 8
	nop	; NOP ; 9
	nop	; NOP ; 10
	nop	; NOP ; 11
	nop	; NOP ; 12
	nop	; NOP ; 13
	nop	; NOP ; 14
	nop	; NOP ; 15
	nop	; NOP ; 16
	nop	; NOP ; 17
	nop	; NOP ; 18
	nop	; NOP ; 19
	nop	; NOP ; 20
	nop	; NOP ; 21
	nop	; NOP ; 22
	decfsz	_sig_p, F
	goto	IrInactive ; DJNZ (_sig_p), IrInactive ; 23, 24, 25
	return	; RET
	
	RETURN	
; exit point of _transmitIrSig

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;functions called:
;   __waitS
;   __waitS
;6 compiler assigned registers:
;   r0x1020
;   r0x1021
;   r0x1022
;   r0x1023
;   r0x1024
;   r0x1025
;; Starting pCode block
S_libirsig__receiveIrSig	code
_receiveIrSig:
; 2 exit points
_00111_DS_:
;	.line	42; "libirsig.c"	while(!IRSNS);							// wait Raising edge of IRSNS (B)
	BANKSEL	_PORTCbits
	BTFSS	_PORTCbits,0
	GOTO	_00111_DS_
;	.line	45; "libirsig.c"	while(IRSNS) {							// wait Falling edge of IRSNS (C)
	BANKSEL	r0x1020
	CLRF	r0x1020
_00116_DS_:
	BANKSEL	_PORTCbits
	BTFSS	_PORTCbits,0
	GOTO	_00138_DS_
	
	movlw 2 ; LD A, 2; 
	
	PAGESEL	__waitS
	CALL	__waitS
	PAGESEL	$
;	.line	47; "libirsig.c"	if(++sig_span > 200) break;
	BANKSEL	r0x1020
	INCF	r0x1020,F
;;swapping arguments (AOP_TYPEs 1/2)
;;unsigned compare: left >= lit(0xC9=201), size=1
	MOVLW	0xc9
	SUBWF	r0x1020,W
	BTFSS	STATUS,0
	GOTO	_00116_DS_
;;genSkipc:3257: created from rifx:0x7ffd66be5820
_00138_DS_:
	BANKSEL	r0x1020
	MOVF	r0x1020,W
	MOVWF	r0x1021
;	.line	53; "libirsig.c"	irsig[sig_p] <<= 1;
	BANKSEL	_sig_p
	MOVF	_sig_p,W
	ADDLW	(_irsig + 0)
	BANKSEL	r0x1022
	MOVWF	r0x1022
	MOVLW	high (_irsig + 0)
	BTFSC	STATUS,0
	ADDLW	0x01
	MOVWF	r0x1023
	MOVF	r0x1022,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1023
	BTFSC	r0x1023,0
	BSF	STATUS,7
	BANKSEL	INDF
	MOVF	INDF,W
	BANKSEL	r0x1024
	MOVWF	r0x1024
	BCF	STATUS,0
	RLF	r0x1024,W
	MOVWF	r0x1025
	MOVF	r0x1022,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1023
	BTFSC	r0x1023,0
	BSF	STATUS,7
	MOVF	r0x1025,W
	BANKSEL	INDF
	MOVWF	INDF
;;swapping arguments (AOP_TYPEs 1/2)
;;unsigned compare: left >= lit(0x1F=31), size=1
;	.line	54; "libirsig.c"	if(sig_span > 30)
	MOVLW	0x1f
	BANKSEL	r0x1020
	SUBWF	r0x1020,W
	BTFSS	STATUS,0
	GOTO	_00120_DS_
;;genSkipc:3257: created from rifx:0x7ffd66be5820
;	.line	55; "libirsig.c"	irsig[sig_p] |= 1;					// check Active (long span) signal
	BANKSEL	_sig_p
	MOVF	_sig_p,W
	ADDLW	(_irsig + 0)
	BANKSEL	r0x1020
	MOVWF	r0x1020
	MOVLW	high (_irsig + 0)
	BTFSC	STATUS,0
	ADDLW	0x01
	MOVWF	r0x1022
	MOVF	r0x1020,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1022
	BTFSC	r0x1022,0
	BSF	STATUS,7
	BANKSEL	INDF
	MOVF	INDF,W
	BANKSEL	r0x1023
	MOVWF	r0x1023
	BSF	r0x1023,0
	MOVF	r0x1020,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1022
	BTFSC	r0x1022,0
	BSF	STATUS,7
	MOVF	r0x1023,W
	BANKSEL	INDF
	MOVWF	INDF
_00120_DS_:
;	.line	57; "libirsig.c"	if(++sig_b == 8) {
	BANKSEL	_sig_b
	INCF	_sig_b,F
	MOVF	_sig_b,W
	XORLW	0x08
	BTFSS	STATUS,2
	GOTO	_00122_DS_
;	.line	58; "libirsig.c"	sig_b = 0;
	CLRF	_sig_b
;	.line	59; "libirsig.c"	sig_p++;
	BANKSEL	_sig_p
	INCF	_sig_p,F
;;swapping arguments (AOP_TYPEs 1/2)
;;unsigned compare: left >= lit(0xC9=201), size=1
_00122_DS_:
;	.line	62; "libirsig.c"	if(sig_span > 200 || sig_p == IRSIGMAX) break;
	MOVLW	0xc9
	BANKSEL	r0x1021
	SUBWF	r0x1021,W
	BTFSC	STATUS,0
	GOTO	_00128_DS_
;;genSkipc:3257: created from rifx:0x7ffd66be5820
	BANKSEL	_sig_p
	MOVF	_sig_p,W
	XORLW	0x1e
	BTFSS	STATUS,2
	GOTO	_00111_DS_
_00128_DS_:
;	.line	64; "libirsig.c"	irsig[sig_p] = 0xFF;						// FIX: over write last byte
	BANKSEL	_sig_p
	MOVF	_sig_p,W
	ADDLW	(_irsig + 0)
	BANKSEL	r0x1020
	MOVWF	r0x1020
	MOVLW	high (_irsig + 0)
	BTFSC	STATUS,0
	ADDLW	0x01
	MOVWF	r0x1021
	MOVF	r0x1020,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1021
	BTFSC	r0x1021,0
	BSF	STATUS,7
	MOVLW	0xff
	BANKSEL	INDF
	MOVWF	INDF
	RETURN	
; exit point of _receiveIrSig

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;2 compiler assigned registers:
;   r0x1026
;   r0x1027
;; Starting pCode block
S_libirsig__clearIrSig	code
_clearIrSig:
; 2 exit points
;	.line	15; "libirsig.c"	for(sig_p = 0; sig_p < IRSIGMAX; sig_p++)	// clear signal buf
	BANKSEL	_sig_p
	CLRF	_sig_p
_00106_DS_:
;	.line	16; "libirsig.c"	irsig[sig_p] = 0;
	BANKSEL	_sig_p
	MOVF	_sig_p,W
	ADDLW	(_irsig + 0)
	BANKSEL	r0x1026
	MOVWF	r0x1026
	MOVLW	high (_irsig + 0)
	BTFSC	STATUS,0
	ADDLW	0x01
	MOVWF	r0x1027
	MOVF	r0x1026,W
	BANKSEL	FSR
	MOVWF	FSR
	BCF	STATUS,7
	BANKSEL	r0x1027
	BTFSC	r0x1027,0
	BSF	STATUS,7
	MOVLW	0x00
	BANKSEL	INDF
	MOVWF	INDF
;	.line	15; "libirsig.c"	for(sig_p = 0; sig_p < IRSIGMAX; sig_p++)	// clear signal buf
	BANKSEL	_sig_p
	INCF	_sig_p,F
;;unsigned compare: left < lit(0x1E=30), size=1
	MOVLW	0x1e
	SUBWF	_sig_p,W
	BTFSS	STATUS,0
	GOTO	_00106_DS_
;;genSkipc:3257: created from rifx:0x7ffd66be5820
;	.line	18; "libirsig.c"	sig_b = -1; sig_p = 0;						// 最初のビットを捨てる
	MOVLW	0xff
	BANKSEL	_sig_b
	MOVWF	_sig_b
	BANKSEL	_sig_p
	CLRF	_sig_p
	RETURN	
; exit point of _clearIrSig


;	code size estimation:
;	  118+   44 =   162 instructions (  412 byte)

	end
