;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (Linux)
;--------------------------------------------------------
; PIC port for the 14-bit core
;--------------------------------------------------------
;	.file	"libusart.c"
	list	p=16f688
	radix dec
	include "p16f688.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_transmitUsartNb
	extern	__waitS
	extern	__waitM
	extern	__waitL
	extern	_forCalibOsc
	extern	_STATUSbits
	extern	_PORTAbits
	extern	_PORTCbits
	extern	_INTCONbits
	extern	_PIR1bits
	extern	_T1CONbits
	extern	_BAUDCTLbits
	extern	_TXSTAbits
	extern	_RCSTAbits
	extern	_WDTCONbits
	extern	_CMCON0bits
	extern	_CMCON1bits
	extern	_ADCON0bits
	extern	_OPTION_REGbits
	extern	_TRISAbits
	extern	_TRISCbits
	extern	_PIE1bits
	extern	_PCONbits
	extern	_OSCCONbits
	extern	_OSCTUNEbits
	extern	_ANSELbits
	extern	_WPUbits
	extern	_WPUAbits
	extern	_IOCbits
	extern	_IOCAbits
	extern	_VRCONbits
	extern	_EECON1bits
	extern	_ADCON1bits
	extern	_waitCntS
	extern	_waitCntM
	extern	_waitCntL
	extern	_INDF
	extern	_TMR0
	extern	_PCL
	extern	_STATUS
	extern	_FSR
	extern	_PORTA
	extern	_PORTC
	extern	_PCLATH
	extern	_INTCON
	extern	_PIR1
	extern	_TMR1
	extern	_TMR1L
	extern	_TMR1H
	extern	_T1CON
	extern	_BAUDCTL
	extern	_SPBRGH
	extern	_SPBRG
	extern	_RCREG
	extern	_TXREG
	extern	_TXSTA
	extern	_RCSTA
	extern	_WDTCON
	extern	_CMCON0
	extern	_CMCON1
	extern	_ADRESH
	extern	_ADCON0
	extern	_OPTION_REG
	extern	_TRISA
	extern	_TRISC
	extern	_PIE1
	extern	_PCON
	extern	_OSCCON
	extern	_OSCTUNE
	extern	_ANSEL
	extern	_WPU
	extern	_WPUA
	extern	_IOC
	extern	_IOCA
	extern	_EEDATH
	extern	_EEADRH
	extern	_VRCON
	extern	_EEDAT
	extern	_EEDATA
	extern	_EEADR
	extern	_EECON1
	extern	_EECON2
	extern	_ADRESL
	extern	_ADCON1

	extern PSAVE
	extern SSAVE
	extern WSAVE
	extern STK12
	extern STK11
	extern STK10
	extern STK09
	extern STK08
	extern STK07
	extern STK06
	extern STK05
	extern STK04
	extern STK03
	extern STK02
	extern STK01
	extern STK00
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_receiveUsart
	global	_transmitUsart
	global	_initUsart
	global	_receiveUsartNb

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_libusart_0	udata
r0x1002	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; code
;--------------------------------------------------------
code_libusart	code
;***
;  pBlock Stats: dbName = C
;***
;has an exit
;1 compiler assigned register :
;   r0x1000
;; Starting pCode block
S_libusart__receiveUsartNb	code
_receiveUsartNb:
; 2 exit points
;	.line	65; "libusart.c"	if(!RCIF)									// 受信フラグチェック
	BANKSEL	_PIR1bits
	BTFSC	_PIR1bits,5
	GOTO	_00135_DS_
;	.line	66; "libusart.c"	return(0x39);
	MOVLW	0x39
	GOTO	_00137_DS_
_00135_DS_:
;	.line	69; "libusart.c"	if(OERR) {								// オーバランエラーチェック
	BANKSEL	_RCSTAbits
	BTFSS	_RCSTAbits,1
	GOTO	_00131_DS_
;	.line	70; "libusart.c"	CREN = 0; CREN = 1;					// 受信回路リセット(OERRクリア)
	BCF	_RCSTAbits,4
	BSF	_RCSTAbits,4
_00131_DS_:
;	.line	72; "libusart.c"	if(FERR) {								// フレーミングエラーチェック
	BANKSEL	_RCSTAbits
	BTFSS	_RCSTAbits,2
	GOTO	_00136_DS_
;	.line	74; "libusart.c"	return(0x38);
	MOVLW	0x38
	GOTO	_00137_DS_
_00136_DS_:
;	.line	78; "libusart.c"	recv = RCREG;								// エラーなし、受信データを得る 
	BANKSEL	_RCREG
	MOVF	_RCREG,W
;;1	MOVWF	r0x1000
_00137_DS_:
;	.line	79; "libusart.c"	return(recv);
	RETURN	
; exit point of _receiveUsartNb

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;1 compiler assigned register :
;   r0x1001
;; Starting pCode block
S_libusart__receiveUsart	code
_receiveUsart:
; 2 exit points
_00114_DS_:
;	.line	46; "libusart.c"	while(!RCIF);							// 受信フラグチェック
	BANKSEL	_PIR1bits
	BTFSS	_PIR1bits,5
	GOTO	_00114_DS_
;	.line	48; "libusart.c"	if(OERR) {								// オーバランエラーチェック
	BTFSS	_RCSTAbits,1
	GOTO	_00118_DS_
;	.line	49; "libusart.c"	CREN = 0; CREN = 1;					// 受信回路リセット(OERRクリア)
	BCF	_RCSTAbits,4
	BSF	_RCSTAbits,4
_00118_DS_:
;	.line	51; "libusart.c"	if(FERR) {								// フレーミングエラーチェック
	BANKSEL	_RCSTAbits
	BTFSS	_RCSTAbits,2
	GOTO	_00123_DS_
;	.line	53; "libusart.c"	continue;
	GOTO	_00114_DS_
_00123_DS_:
;	.line	57; "libusart.c"	recv = RCREG;								// エラーなし、受信データを得る 
	BANKSEL	_RCREG
	MOVF	_RCREG,W
;;1	MOVWF	r0x1001
;	.line	58; "libusart.c"	return(recv);
	RETURN	
; exit point of _receiveUsart

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;1 compiler assigned register :
;   r0x1002
;; Starting pCode block
S_libusart__transmitUsart	code
_transmitUsart:
; 2 exit points
;	.line	30; "libusart.c"	void transmitUsart(unsigned char c) {
	BANKSEL	r0x1002
	MOVWF	r0x1002
_00109_DS_:
;	.line	32; "libusart.c"	while(!TRMT);
	BANKSEL	_TXSTAbits
	BTFSS	_TXSTAbits,1
	GOTO	_00109_DS_
;	.line	33; "libusart.c"	TXREG = c;								// USART Transmit data register
	BANKSEL	r0x1002
	MOVF	r0x1002,W
	BANKSEL	_TXREG
	MOVWF	_TXREG
	RETURN	
; exit point of _transmitUsart

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_libusart__initUsart	code
_initUsart:
; 2 exit points
;	.line	14; "libusart.c"	SPBRG	= BAUDRATE;				// Baud Rate Generator
	MOVLW	0x19
	BANKSEL	_SPBRG
	MOVWF	_SPBRG
;	.line	15; "libusart.c"	BRGH	= 1;					// High Baud Rate Select(High/Low)
	BSF	_TXSTAbits,2
;	.line	17; "libusart.c"	SYNC	= 0;					// USART Mode Select(Synchronous/Asynchronous)
	BCF	_TXSTAbits,4
;	.line	19; "libusart.c"	SPEN	= 1;					// Serial Port Enable
	BSF	_RCSTAbits,7
;	.line	20; "libusart.c"	CREN	= 1;					// Continuous Receive Enable
	BSF	_RCSTAbits,4
;	.line	22; "libusart.c"	TXEN	= 1;					// Transmit Enable
	BSF	_TXSTAbits,5
	RETURN	
; exit point of _initUsart


;	code size estimation:
;	   39+   12 =    51 instructions (  126 byte)

	end
